/*
 * sht21.c
 *
 * Created: 7/31/2012 1:27:19 AM
 *  Author: Andrei Voinescu
 */ 

#include "sht21.h"

void twiInit()
{
    PRR0 &= ~_BV(PRTWI);                // activate TWI in the Power reduction register
    //TWSR |= _BV(TWPS0) | _BV(TWPS1);
    //#define TWI_FREQ 100000
    TWBR = 72;//((F_CPU / TWI_FREQ) - 16) / 2;
	//TWBR = 255;//((F_CPU / TWI_FREQ) - 16) / 2;
    //TWCR = _BV(TWEN) | _BV(TWEA);
    TWSR = 0;
    TWAR = 0;
}

uint8_t SHTstarti2c()
{
	
	TWCR = _BV(TWINT) | _BV(TWSTA) | _BV(TWEN);
	loop_until_bit_is_set(TWCR, TWINT);
	
	return ((TWSR & 0xf8) != 0x08) && ((TWSR & 0xf8) != 0x10);
}

__inline__ void SHTstopi2c()
{
	TWCR = _BV(TWINT) | _BV(TWSTO) | _BV(TWEN);
}
__inline__ uint8_t SHTreadi2c(uint8_t * byte, uint8_t retcheck, uint8_t extraflag)
{
	TWCR = _BV(TWINT) | _BV(TWEN) | extraflag;
	loop_until_bit_is_set(TWCR, TWINT);
	*byte = TWDR;
	return (TWSR & 0xf8) != retcheck;
}
__inline__ uint8_t SHTwritei2c(uint8_t byte, uint8_t retcheck, uint8_t extraflag)
{
	TWDR = byte;
	TWCR = _BV(TWINT) | _BV(TWEN) | extraflag;
	loop_until_bit_is_set(TWCR, TWINT);
	
	return (TWSR & 0xf8) != retcheck;
}

uint16_t changeResolution()
{
	uint8_t readbyte;       // 8bit value read from i2c
	////change resolution
	
	if (SHTstarti2c()) 
	    goto stop;
	if (SHTwritei2c(SHT_ADDRESS | SHT_READ, 0x18, 0)) 
	    goto stop;
	if (SHTwritei2c(0xE7, 0x28, 0)) 
	    goto stop;
	
	if (SHTstarti2c())
		goto stop;
	if (SHTwritei2c(SHT_ADDRESS | SHT_WRITE, 0x40, 0))
	    goto stop;
	if (SHTreadi2c(&readbyte, 0x50, _BV(TWEA)))
		goto stop;
	
	if (SHTstarti2c())
		goto stop;
	if (SHTwritei2c(SHT_ADDRESS | SHT_READ, 0x18, 0))
	    goto stop;
	if (SHTwritei2c(0xE6, 0x28, 0)) 
	    goto stop;		
	if (SHTwritei2c(0x03, 0x28, 0)) 
	    goto stop;
	
	SHTstopi2c();
	
	////changed resolution
	return 0;
	
stop:
    SHTstopi2c();
	return 1;
}

uint16_t SHTReadValueNoHold()
{
	uint16_t retvalue=0;    // 16bit return value
	uint8_t readbyte;       // 8bit value read from i2c
	
	SHTstarti2c();
	    
	if (SHTwritei2c(SHT_ADDRESS | SHT_WRITE, 0x40, 0))
	    goto stop;
	if (SHTreadi2c(&readbyte, 0x50, _BV(TWEA)))
		goto stop;	
	retvalue = readbyte;
	if (SHTreadi2c(&readbyte, 0x50, _BV(TWEA)))
	    goto stop;
	retvalue = (retvalue << 8) + (readbyte & 0xfc);
	
	if (SHTreadi2c(&readbyte, 0x50, _BV(TWEA)))
	    goto stop;
    SHTstopi2c();
	return retvalue;
stop:
    SHTstopi2c();
	return 0x4242;
}

uint16_t SHTCommandNoHold(uint8_t address)
{
	// call changeResolution by hand
	//if(changeResolution())
	//	goto stop;
	
    if (SHTstarti2c()) 
	    goto stop;
	if (SHTwritei2c(SHT_ADDRESS | SHT_READ, 0x18, 0)) 
	    goto stop;
	if (SHTwritei2c(address, 0x28, 0)) 
	    goto stop;
	
	SHTstopi2c();
	return 0;
stop:
    SHTstopi2c();
	return 1;
}

uint16_t SHTReadValue(uint8_t address)
{
	uint16_t retvalue=0;    // 16bit return value
	uint8_t readbyte;       // 8bit value read from i2c
	
	//if(changeResolution())
		//goto stop;
	
    if (SHTstarti2c()) 
	    goto stop;
	if (SHTwritei2c(SHT_ADDRESS | SHT_READ, 0x18, 0)) 
	    goto stop;
	if (SHTwritei2c(address, 0x28, 0)) 
	    goto stop;
	
	SHTstopi2c();
	
	SHTstarti2c();
	    
	if (SHTwritei2c(SHT_ADDRESS | SHT_WRITE, 0x40, 0))
	    goto stop;
	if (SHTreadi2c(&readbyte, 0x50, _BV(TWEA)))
		goto stop;	
	retvalue = readbyte;
	if (SHTreadi2c(&readbyte, 0x50, _BV(TWEA)))
	    goto stop;
	retvalue = (retvalue << 8) + (readbyte & 0xfc);
	
	if (SHTreadi2c(&readbyte, 0x50, _BV(TWEA)))
	    goto stop;
    SHTstopi2c();
	return retvalue;
stop:
    SHTstopi2c();
	return 0x4242;
}